#include <iostream>

#include "TObject.h"

#include "CDataSample.hh"

ClassImp(CDataSample)

CDataSample::CDataSample() : CData(), x(0), y(0), z(0), r(0), deque_d()
{;}

CDataSample::CDataSample(const char* name, const char* title) : CData(name, title),
								x(0),
								y(0),
								z(0),
								r(0),
								deque_d()
{;}

CDataSample::CDataSample(const TString& name, const TString& title) : CData(name, title),
								      x(0),
								      y(0),
								      z(0),
								      r(0),
								      deque_d()
{;}

CDataSample::CDataSample(const CDataSample& datasample) : CData(datasample),
							  x(datasample.x),
							  y(datasample.y),
							  z(datasample.z),
							  r(datasample.r),
							  deque_d(datasample.deque_d)
{;}

CDataSample& CDataSample::operator=(const CDataSample& rhs)
{
  if(this != &rhs){
    CData::operator=(rhs);
    x = rhs.x;
    y = rhs.y;
    z = rhs.z;
    r = rhs.r;
    deque_d = rhs.deque_d;
  }
  return *this;
}

CDataSample::~CDataSample()
{;}

void CDataSample::Reset()
{
  CData::Reset();
  deque_d.clear();
}
