#ifndef CMAPFUNCTION_HH
#define CMAPFUNCTION_HH

#include <deque>
#include <string>

#include "TF1.h"

class CMapFunction
{
public:
  CMapFunction();
  ~CMapFunction();

  typedef double type_map;
  typedef std::vector<type_map> type_map1d;
  typedef std::vector<type_map1d> type_map2d;
  typedef std::vector<type_map2d> type_map3d;

  TF1* GetMapFunction();
  double GetXmin(){return m_xmin;}
  double GetXmax(){return m_xmax;}
  double GetYmin(){return m_ymin;}
  double GetYmax(){return m_ymax;}
  double GetZmin(){return m_zmin;}
  double GetZmax(){return m_zmax;}
  double GetOffsetx(){return m_offsetx;}
  double GetOffsety(){return m_offsety;}
  double GetOffsetz(){return m_offsetz;}
  double GetIntervalx(){return m_intervalx;}
  double GetIntervaly(){return m_intervaly;}
  double GetIntervalz(){return m_intervalz;}

  virtual int SetFile(std::string filename) = 0;
  virtual void Print() = 0;

protected:
  TF1* fMapFunction;

  double m_offsetx, m_offsety, m_offsetz;
  double m_intervalx, m_intervaly, m_intervalz;
  double m_xmin, m_xmax, m_ymin, m_ymax, m_zmin, m_zmax;

  ClassDef(CMapFunction, 0)
};

#endif
