#ifndef FFUNCTION_HH
#define FFUNCTION_HH

#include "TROOT.h"

Double_t VirtualResonance(Double_t xx, Double_t a, Double_t r0,
			  Double_t Eb, Double_t ma, Double_t mb);
Double_t VirtualResonance(Double_t *x, Double_t *par);

Double_t BrietWigner(Double_t xx, Double_t er, Double_t gamma);
Double_t BrietWigner(Double_t *x, Double_t *par);

Double_t BrietWigner2(Double_t xx, Double_t k, Double_t er1, Double_t gamma1, Double_t er2, Double_t gamma2);
Double_t BrietWigner2(Double_t *x, Double_t *par);

Double_t Gaussian(Double_t xx, Double_t mean, Double_t sigma);
Double_t Gaussian(Double_t *x, Double_t *par);

Double_t Poisson(Double_t x, Double_t par);
Double_t Poisson(Double_t *x, Double_t *par);

Double_t SquareWave(Double_t xx, Double_t hight, Double_t width, Double_t period);
Double_t SquareWave(Double_t *x, Double_t *par);

#endif
