#ifndef FREADFILE_HH
#define FREADFILE_HH

#include "TROOT.h"

#include "CMapFunction.hh"

#include <string>

class FReadFile
{
public:
  //fileからデータの配列を読み込んでvectorに格納する。
  static int ReadIn(std::string filename, CMapFunction::type_map2d& xy);
  //読み込んだvectorを降順で行列の形にvectorに格納する。
  //読み込んだvector, 新しいvector(行列), xindex, yindex, findex
  static int ReFill(CMapFunction::type_map2d xy, 
		    CMapFunction::type_map2d& xy_new, 
		    int xindex, int yindex, int findex);
  //xyが1/4しかデータがないときに4倍に拡張する。
  static int ReFillQuad(CMapFunction::type_map2d xy,
			CMapFunction::type_map2d& xy_new4,
			int xindex, int yindex, int findex);
  //vector<vector<double> > を一気にprintする
  static void Check(const CMapFunction::type_map2d& xy);
  static void Print(const CMapFunction::type_map2d& xy);

private:
  //ソートのためのプレディケート
  class FLessX
  {
  public:
    static void SetIndex(int index){m_index = index;}
    bool operator()(const CMapFunction::type_map1d& riLeft,
		    const CMapFunction::type_map1d& riRight) const
    {
      return riLeft[m_index] < riRight[m_index];
    }

  private:
    static int m_index;
  };

  //ソートのためのプレディケート
  class FLessY
  {
  public:
    static void SetIndex(int index){m_index = index;}
    bool operator()(const CMapFunction::type_map1d& riLeft,
		    const CMapFunction::type_map1d& riRight) const
    {
      return riLeft[m_index] < riRight[m_index];
    }

  private:
    static int m_index;
  };

  ClassDef(FReadFile, 0)
};

#endif
